#include "common.cc.h"
#include "common.c.h"
#include <string.h>

#include "chld.cc"

static int conti = 1;
static void handler( int signo ) { conti = 0; }; 

static char b[ 1024 ] = "";

int main( int argc, char *argv[] ) {
   cout << "вариант сборки " << VARIANT << endl;
   if( argc < 2 )
      cout << "illegal parameters number" << endl,
      exit( EXIT_FAILURE );
   signal( SIGINT, handler ); 
   for( int i = 1; i < argc; i++ )  // строка вызова дочернего процесса
      sprintf( b + strlen( b ), "%s ", argv[ i ] );
   // описания разных вариантов сборки:
#if VARIANT == 1
   // вариант 1-й, с использованием перехваченных файловых 
   // дескрипторов, в манере самого классического C: 
   int fdi, fdo;
   chld *ch = new chld( b, &fdi, &fdo );
   int n;
   // читаем заголовочное сообщение о параметрах:
   if( ( n = read( fdi, b, sizeof( b ) - 2 ) ) == -1 )
      perror( "read pipe" ), exit( EXIT_FAILURE );
   b[ n ] = '\0';
   cout << b << flush;
   // а дальше – цикл ввода с консоли, передачи клиенту, 
   // ретрансляции клиентом, и вывод того, что от него получено:
   while( conti ) {
      fgets( b, sizeof( b ) - 2, stdin );
      if( !conti ) break; 
      strcat( b, "\n" );      
      if( write( fdo, b, strlen( b ) ) == -1 )
         perror( "write pipe" ), exit( EXIT_FAILURE );
      if( ( n = read( fdi, b, sizeof( b ) - 2 ) ) == -1 )
         perror( "read pipe" ), exit( EXIT_FAILURE );
      b[ n ] = '\0'; cout << b << flush;
   };
#elif VARIANT == 2
   // вариант 2-й, с использованием переопределённых операций
   // << & >> - нам при этом даже нет необходимости определять
   // и знать дескрипторы, через которые это происходит:
   chld *ch = new chld( b );
   // читаем заголовочное сообщение о параметрах:
   *ch >> b; cout << b << flush;
   while( conti ) {
      fgets( b, sizeof( b ) - 2, stdin );
      if( !conti ) break; 
      strcat( b, "\n" );      
      ( *ch << b ) >> b; cout << ch->buf << flush;
   };
#else 
#error 'недопустимое значение VARIANT (в Makefilr)' 
#endif
   delete ch; // остановка дочернего процесса
   cout << "child process stop!" << endl;
   exit( EXIT_SUCCESS );
}
