#include <arpa/inet.h>
#include  "common.h"

void dg_cli( FILE* fp, int sockfd,
             struct sockaddr* pserv_addr, // ptr to appropriate sockaddr structure 
             int servlen ) {	          // actual sizeof(*pserv_addr) 
   int n;
   char line[ MAXLEN ]; 
   while( fgets( line, MAXLEN, fp ) != NULL ) {
      n = strlen( line );
      if( sendto( sockfd, line, n, 0, pserv_addr, servlen ) != n )
         printf( "send: %m\n" ), exit( EXIT_FAILURE );
      if( ( n = recvfrom( sockfd, line, MAXLEN, 0,
                          (struct sockaddr*)NULL, (socklen_t*)NULL ) ) < 0 )
         printf( "recv: %m\n" ), exit( EXIT_FAILURE );
      line[ n ] = '\0';                // null terminate 
      fputs( line, stdout );
      if( strstr( line, SDELIM ) == NULL ) continue;
      if( strlen( strstr( line, SDELIM ) ) == strlen( SDELIM ) + 1 )
         printf( "server exit\n" );
   }
}

int main( int argc, char* argv[] ) {
   char serv_host_addr[ 16 ] = "127.0.0.1";                 // host addr for server 
   int serv_udp_port = 50010;                               // server UDP port
   if( argc > 1 ) strcpy( serv_host_addr, argv[ 1 ] ); 
   if( argc > 2 ) serv_udp_port = atoi( argv[ 2 ] ); 
   printf( "UDP server: %s:%d\n", serv_host_addr, serv_udp_port );
   int sockfd;
   if( ( sockfd = socket( AF_INET, SOCK_DGRAM, 0 ) ) < 0 )  // open a UDP socket
      printf( "socket: %m\n" ), exit( EXIT_FAILURE );
   struct sockaddr_in serv_addr;
   bzero( (char*)&serv_addr, sizeof( serv_addr ) );         // fill address structure
   serv_addr.sin_family      = AF_INET;
   serv_addr.sin_addr.s_addr = inet_addr( serv_host_addr );
   serv_addr.sin_port        = htons( serv_udp_port );
   dg_cli( stdin, sockfd, (struct sockaddr*)&serv_addr, sizeof( struct sockaddr_in ) );
   close( sockfd );
   exit( EXIT_SUCCESS );
}
