#include  <syslog.h>
#include  "common.h"

int main( void ) {    // добавить запись UDP порта в /etc/services и в конфигурацию в /etc/xinetd.d
   char rbuf[ MAXLEN ], wbuf[ MAXLEN + 8 ];
   openlog( NULL, LOG_NDELAY, LOG_USER );
   syslog( LOG_NOTICE, "%s", "server start" );
   while( 1 ) {
      struct sockaddr_in adr;
      socklen_t len = sizeof( struct sockaddr_in );
      int n = recvfrom( STDIN_FILENO, rbuf, MAXLEN, 0,    // чтение пакета из SYSIN для xinetd:
                        (struct sockaddr*)&adr, &len ); 
      if( n >= 0 ) syslog( LOG_NOTICE, "server read %d byte", n );
      if( n <= 0 ) {
         if( n < 0 ) syslog( LOG_ERR, "recvfrom error: %s", strerror( errno ) );
         break;
      }
      rbuf[ n ] = '\0';
      sleep( 1 );                                         // имитация времени обработки
      sprintf( wbuf, "[%d]%s%s", getpid(), SDELIM, rbuf );
      if( sendto( STDOUT_FILENO, wbuf, strlen( wbuf ), 0, // ретрансляция пакета в SYSOUT для xinetd:
                  (struct sockaddr*)&adr, sizeof( struct sockaddr_in ) ) != n ) {
         syslog( LOG_ERR, "sendto error: %s", strerror( errno ) );
         break;
      }
   }
   syslog( LOG_NOTICE, "%s", "server exit" );
   closelog();
   exit( EXIT_SUCCESS );
};
