#include "common.h"

void dg_cli( FILE *fp, int sockfd, const struct sockaddr *pservaddr,
             socklen_t servlen ) {
   int  n;
   char sendline[ MAXLINE ], recvline[ MAXLINE + 1 ];
   socklen_t len;
   struct sockaddr *preply_addr;
   preply_addr = malloc( servlen );
   while( 1 ) {
      printf( "> " ); fflush( stdout );
      if( NULL == fgets( sendline, MAXLINE, fp ) ) {
         printf( "\n" ); break;
      }
      sendto( sockfd, sendline, strlen( sendline ), 0, pservaddr, servlen );
      len = servlen;
      n = recvfrom( sockfd, recvline, MAXLINE, 0, preply_addr, &len );
      if( len != servlen || memcmp( pservaddr, preply_addr, len ) != 0 ) {
         printf( "reply wrong and ignored: %d\n", len );
         continue;
      }
      recvline[ n ] = 0; /* null terminate */
      printf( "%s", recvline );
   }
}

int main( int argc, char **argv ) {
   char saddr[ 40 ] = "127.0.0.1";
   int opt, val, port = SERV_PORT, sockfd;
   struct sockaddr_in servaddr;
   while( ( opt = getopt( argc, argv, "a:p:") ) != -1 ) {
      switch( opt ) {
         case 'a' :
            strcpy( saddr, optarg );
            break;
         case 'p' :
            if( sscanf( optarg, "%i", &val ) != 1 ) 
               printf( "parse command line failed" ), exit( EINVAL );
            port = val;
            break;
         default :
            printf( "usage: %s [-a IPaddress] [-p UDPport]\n", argv[ 0 ] ),
            exit( EXIT_FAILURE );
      }
   };
   bzero( &servaddr, sizeof( servaddr ) );
   servaddr.sin_family = AF_INET;
   servaddr.sin_port = htons( port );
   if( inet_pton( AF_INET, saddr, &servaddr.sin_addr ) != 1 )
      perror( "address" ), exit( EXIT_FAILURE );;
   sockfd = socket( AF_INET, SOCK_DGRAM, 0 );
   dg_cli( stdin, sockfd, (struct sockaddr*)&servaddr, sizeof( servaddr ) );
   exit( EXIT_SUCCESS );
}
