#include "common.h"
// уберите запись UDP порта SERV_PORT из /etc/services и из конфигураций /etc/inetd.d !

static int count = 0, debug = 0;

static void recvfrom_int( int signo ) {
   printf( "\nreceived %d datagrams\n", count );
   exit( EXIT_SUCCESS );
}

void dg_echo( int sockfd, struct sockaddr *pcliaddr, socklen_t clilen ) {
   int  n;
   socklen_t len;
   char mesg[ MAXLINE ];
   signal( SIGINT, recvfrom_int );
   for ( ; ; ) {
      len = clilen;
      n  = recvfrom( sockfd, mesg, MAXLINE, 0, pcliaddr, &len );
      if( debug ) printf( "%s", mesg );
      sendto( sockfd, mesg, n, 0, pcliaddr, len );
      count++;
   }
}

int main( int argc, char **argv ) {
   struct sockaddr_in servaddr, cliaddr;
   int opt, port = SERV_PORT,
       sockfd = socket( AF_INET, SOCK_DGRAM, 0 );
   while( ( opt = getopt( argc, argv, "p:v") ) != -1 ) {
      int val;
      switch( opt ) {
         case 'p' :
            if( sscanf( optarg, "%i", &val ) != 1 )
               printf( "parse command line failed" ), exit( EINVAL );
            port = val;
            break;
         case 'v' :
            debug++;
            break;
         default :
            printf( "usage: %s [-p UDPport] [-v]\n", argv[ 0 ] ),
            exit( EXIT_FAILURE );
      }
   };
   bzero( &servaddr, sizeof( servaddr ) );
   servaddr.sin_family = AF_INET;
   servaddr.sin_addr.s_addr = htonl( INADDR_ANY );
   servaddr.sin_port  = htons( port );
   if( 0 != bind( sockfd, (struct sockaddr*)&servaddr, sizeof( servaddr ) ) )
      perror( "bing" ), exit( EXIT_FAILURE );
   dg_echo( sockfd, (struct sockaddr*)&cliaddr, sizeof( cliaddr ) );
   exit( EXIT_SUCCESS );
}
